{r6502 test program } 
PUB GetPointerTo6502Program

        result                  := @test_program
DAT   

test_program

{ Program Origin $6000

                zero = $30
                nine = $39

              screen = $7bff

              numbers = $7cc7

        lda #zero       'get zero digit loaded
        ldx #8          'we are gonna do 8 digits
digits  sta numbers, x          'put them on screen, right to left
        dex                     'next digit?
        cpx #0                  'done ?
        bne digits              'no, continue writing digits to screen!

                                'yes, move on to counting on them....


'hand assembly until I get the 400 sorted, or DASM or something...
'this code is relocatable and simple, so it can be put right into the test proggy with no worries
'which is where it is right now!

'this is unchanged from the first one.  Added a test HALT instruction.

}

'boot strap test loop!  Just enough to code a few instructions and prove out the CPU workflow
'Initialize the digits

byte byte  $a9, $30          '         lda #zero
byte byte  $a2, $08          '         ldx #8
byte byte  $9d, $c7, $7c     'digits   sta numbers, x    (check endian on this one)
byte byte  $ca               '         dex
byte byte  $e0, $00          '         cpx #0
byte byte  $d0, $f8          '         bne digits        (check branch offset)
'byte byte  $ff                         '##halt##

'ready to count them up!  Enough of a test to gauge speed and work out greater emulation structure

byte byte  $a0, $30             '         ldy #zero        'have this handy...
byte byte  $a2, $08             'count1   ldx #8           'back to first digit
byte byte  $fe, $c7, $7c        '         inc numbers, x   'increment first one
byte byte  $bd, $c7, $7c        '         lda numbers, x   'look it over
byte byte  $44, $3a             '         cmp #nine + 1    'are we over nine? 
byte byte  $d0, $f4             '         bne count1       'no, keep going...
byte byte  $98                  '         tya 
byte byte  $9d, $c7, $7c        '         sta numbers, x   'reset digit count
byte byte  $ca                  '         dex              'point to next digit
byte byte  $fe, $c7, $7c        '         inc numbers, x   'increment it
byte byte  $bd, $c7, $7c        '         lda numbers, x
byte byte  $44, $3a             '         cmp #nine + 1
byte byte  $d0, $ef             '         bne count1
byte byte  $98                  '         tya 
byte byte  $9d, $c7, $7c        '         sta numbers, x   
byte byte  $ca                  '         dex              
byte byte  $fe, $c7, $7c        '         inc numbers, x   
byte byte  $bd, $c7, $7c        '         lda numbers, x
byte byte  $44, $3a             '         cmp #nine + 1
byte byte  $d0, $ef             '         bne count1
byte byte  $98                  '         tya 
byte byte  $9d, $c7, $7c        '         sta numbers, x   
byte byte  $ca                  '         dex              
byte byte  $fe, $c7, $7c        '         inc numbers, x   
byte byte  $bd, $c7, $7c        '         lda numbers, x
byte byte  $44, $3a             '         cmp #nine + 1
byte byte  $d0, $ef             '         bne count1
byte byte  $98                  '         tya 
byte byte  $9d, $c7, $7c        '         sta numbers, x   
byte byte  $ca                  '         dex              
byte byte  $fe, $c7, $7c        '         inc numbers, x   
byte byte  $bd, $c7, $7c        '         lda numbers, x
byte byte  $44, $3a             '         cmp #nine + 1
byte byte  $d0, $ef             '         bne count1
byte byte  $98                  '         tya 
byte byte  $9d, $c7, $7c        '         sta numbers, x   
byte byte  $ca                  '         dex              
byte byte  $fe, $c7, $7c        '         inc numbers, x   
byte byte  $bd, $c7, $7c        '         lda numbers, x
byte byte  $44, $3a             '         cmp #nine + 1
byte byte  $d0, $ef             '         bne count1
byte byte  $98                  '         tya 
byte byte  $9d, $c7, $7c        '         sta numbers, x   
byte byte  $ca                  '         dex              
byte byte  $fe, $c7, $7c        '         inc numbers, x   
byte byte  $bd, $c7, $7c        '         lda numbers, x
byte byte  $44, $3a             '         cmp #nine + 1
byte byte  $d0, $ef             '         bne count1
byte byte  $98                  '         tya 
byte byte  $9d, $c7, $7c        '         sta numbers, x   
byte byte  $ca                  '         dex              
byte byte  $fe, $c7, $7c        '         inc numbers, x   
byte byte  $bd, $c7, $7c        '         lda numbers, x
byte byte  $44, $3a             '         cmp #nine + 1
byte byte  $d0, $ef             '         bne count1
byte byte  $ff                         '##halt##              'This is a potatohead instruction, to be deleted.